#!/bin/bash

# Check custom settings
if [ ! -e ./settings.custom ]; then
 clear
 echo "[i] ./settings.custom does not exist, please"
 echo "[i] copy settings.tpl as settings.custom, cp settings.tpl settings.custom, then custommize settings.custom and execute this script again"
 exit 1
fi
source ./settings.custom
#
NOW=`date +%Y-%m-%d_%Hh%m%Ss`
#
docker cp ./license/configq1.zip ${KIUWAN_HOST}:/tmp/.
docker cp ./license/license.zip ${KIUWAN_HOST}:/tmp/.
STATUS=`docker exec -it ${KIUWAN_HOST} supervisorctl status wildfly | awk '{print $2}'`
if [ "${STATUS}" = "RUNNING" ]; then
	docker exec -it ${KIUWAN_HOST} supervisorctl stop wildfly
fi
KIUWAN_USER=`docker exec -it ${KIUWAN_HOST} ls -ld ${KIUWAN_VOL}/configq1 | awk '{print $3}'`
KIUWAN_GROUP=`docker exec -it ${KIUWAN_HOST} ls -ld ${KIUWAN_VOL}/configq1 | awk '{print $4}'`

docker exec -it ${KIUWAN_HOST} unzip -o /tmp/configq1.zip -d ${KIUWAN_VOL}/configq1
docker exec -it ${KIUWAN_HOST} chown -R ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/configq1 

KIUWAN_USER=`docker exec -it ${KIUWAN_HOST} ls -ld ${KIUWAN_VOL}/license | awk '{print $3}'`
KIUWAN_GROUP=`docker exec -it ${KIUWAN_HOST} ls -ld ${KIUWAN_VOL}/license | awk '{print $4}'`

docker exec -it ${KIUWAN_HOST} unzip -o /tmp/license.zip -d ${KIUWAN_VOL}/license
docker exec -it ${KIUWAN_HOST} chown -R ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/license

docker exec -it ${KIUWAN_HOST} rm -f /tmp/configq1.zip /tmp/license.zip
docker exec -it ${KIUWAN_HOST} mv ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log.${NOW}
docker exec -it ${KIUWAN_HOST} supervisorctl start wildfly
sleep 10
docker exec -it ${KIUWAN_HOST} /bin/sh -c "/usr/bin/tail -n -1 -f ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log | { /bin/sed '/started in/ q' && /usr/bin/killall tail ;}"
