#!/bin/bash
#

KIUWAN_VOL=
MYSQL_SERVER=
MYSQL_PORT=
MYSQL_CONNECT_STRING=
KIUWAN_MYSQL_USER=
KIUWAN_MYSQL_PWD=
KIUWAN_ROOT_URL=
APPS_VERSION=
KIUWAN_USER=
KIUWAN_GROUP=
MYSQL_JCONNECTOR_VERSION=
KIUWAN_EMAIL_ADMIN_ACCOUNT=
#
INSTALL_BASE=/opt
DIR_BACKUPS_DIST="$KIUWAN_VOL/back_before_deploy"
DIR_DEPLOYCONFIG="$KIUWAN_VOL/deployconfig"
DIR_DEPLOYMENTS=deployments
DIR_APP_TO_DEPLOY=saas.war
DIR_RELEASE="$KIUWAN_VOL/release"
DIR_RELEASE_DIST_TEMP=/tmp/optimyth-cinc-distribution
# ----------------------------------------------------------------------

desplegarApp () {
  if [ -e $INSTALL_BASE/wildfly-$APPS_VERSION/standalone/configuration/standalone_xml_history/current ]; then
	rm -rf $INSTALL_BASE/wildfly-$APPS_VERSION/standalone/configuration/standalone_xml_history/current
  fi
  if [ -e $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY ]; then
    /bin/mv $INSTALL_BASE/wildfly-$APPS_VERSION/standalone/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY $DIR_BACKUPS_DIST/$DIR_APP_TO_DEPLOY-`date +%Y-%m-%d_%H_%M_%S`
    /bin/rm -f $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY.*
  fi
  if [ -e $DIR_RELEASE_DIST_TEMP ]; then
    /bin/rm -rf $DIR_RELEASE_DIST_TEMP
  fi	
  /usr/bin/unzip $DIR_RELEASE/optimyth-cinc-distribution-`cat $DIR_RELEASE/todeploy.version`.jar -d $DIR_RELEASE_DIST_TEMP
  /usr/bin/unzip $DIR_RELEASE_DIST_TEMP/dist/optimyth-cinc-web-*.war -d $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY
  if [ -e $DIR_RELEASE/installation ]; then
	  /bin/rm -rf $DIR_RELEASE/installation
  fi
  if [ -e $DIR_RELEASE/qmm ]; then
	  /bin/rm -rf $DIR_RELEASE/qmm
  fi
  if [ -e $DIR_RELEASE/upgrade ]; then
	  /bin/rm -rf $DIR_RELEASE/upgrade
  fi
  /bin/cp -rf /tmp/optimyth-cinc-distribution/installation -d $DIR_RELEASE/.
  sed -i -e 's|https://www.kiuwan.com|'"$KIUWAN_ROOT_URL"'|g'  $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/classes/mail/varImagesUri.vm
  sed -i -e 's|https://www.kiuwan.com|'"$KIUWAN_ROOT_URL"'|g'  $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/classes/mail/varKiuwanLink.vm
  sed -i -e 's|kiuwan.com|Kiuwan|g'  $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/classes/mail/varKiuwanLink.vm
  sed -i -e 's|https://www.kiuwan.com|'"$KIUWAN_ROOT_URL"'|g'  $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/classes/mail/varKiuwanLoginURL.vm
  sed -i -e 's|kiuwan.com|Kiuwan|g'  $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/classes/mail/varKiuwanLoginURL.vm
  sed -i -e 's|https://www.kiuwan.com|'"$KIUWAN_ROOT_URL"'|g'  $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/classes/mail/varKiuwanSignUpURL.vm
  sed -i -e 's|kiuwan.com|Kiuwan|g'  $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/classes/mail/varKiuwanSignUpURL.vm
  sed -i -e 's|https://www.kiuwan.com|'"$KIUWAN_ROOT_URL"'|g'  $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/classes/mail/varKiuwanURL.vm
  sed -i -e 's|https://www.kiuwan.com|'"$KIUWAN_ROOT_URL"'|g'  $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/classes/mail/varRegistrationFormAddress.vm
  echo "$KIUWAN_EMAIL_ADMIN_ACCOUNT" > $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/classes/mail/varSupportMailAddress.vm
  
  # mergeFromDir contains the current properties already configured
  # mergeToDir is the new deployment to configure
  # get the files in mergeFromDir, and look for a matching file in mergeToDir
  # overwrite the existing mergeToDir file with the resulting merge
  # note that we only support new properties already configured in the new war by now
  mergeFromDir=$DIR_DEPLOYCONFIG/kiuwan/configuration
  mergeToDir=$KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY
  cd $mergeFromDir; for filename in $(find . -type f); do
    if [ -f "$mergeToDir/$filename" ]
      then
        source="$mergeFromDir/$filename"
        target="$mergeToDir/$filename"
        echo "Found $target, merging files..."
        result=$(awk -F= '!a[$1]++' $source $target)
        echo "$result" > "$target"
        echo "File $target merged"
      else
        echo "File $target not found, ignoring merge for this file..."
    fi
  done
  
  /bin/cp $DIR_RELEASE/todeploy.version $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/current.version
  /bin/cp /opt/libraries/mysql-connector-java-${MYSQL_JCONNECTOR_VERSION}-bin.jar $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/WEB-INF/lib/.
  /bin/cp /opt/libraries/mysql-connector-java-${MYSQL_JCONNECTOR_VERSION}-bin.jar $DIR_RELEASE/installation/lib/.
  sed -i -e 's|^db.connection.host=.*|db.connection.host='"${MYSQL_SERVER}"'|' $DIR_RELEASE/installation/conf/db-connection.properties
  sed -i -e 's|^db.connection.port=.*|db.connection.port='"${MYSQL_PORT}"'|' $DIR_RELEASE/installation/conf/db-connection.properties
  sed -i -e 's|KIUWAN_MYSQL_USER|'"${KIUWAN_MYSQL_USER}"'|g' $DIR_RELEASE/installation/conf/db-connection.properties
  sed -i -e 's|KIUWAN_MYSQL_PWD|'"${KIUWAN_MYSQL_PWD}"'|g' $DIR_RELEASE/installation/conf/db-connection.properties
  
  /usr/bin/touch $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY.dodeploy
 
  /bin/chown -R $KIUWAN_USER:$KIUWAN_GROUP $INSTALL_BASE/wildfly-$APPS_VERSION \
		$KIUWAN_VOL/$DIR_DEPLOYMENTS \
		$DIR_RELEASE 
}

# ----
# Main
# ----
desplegarApp
exit 0
