#!/bin/bash
#
NOW=`date +%Y-%m-%d_%Hh%m%Ss`
#
if [ "$0" != "./patch_1.sh" ]; then
  clear
  echo "[i] Please, this script must be executed without absolute path, excute it as ./patch_1.sh from its owned directory"
  exit 1
fi
setting_dir=`pwd`
patch_dir=${setting_dir}
setting_dir=`echo ${setting_dir} | awk -F "/updates" '{print $1}'`

# Check ssl custom
if [ ! -e ${setting_dir}/ssl/ssl.custom ]; then
 clear
 echo "[i] File ${setting_dir}/ssl/ssl.custom does not exist, it is not necesary to apply this patch"
 exit 1
fi
source ${setting_dir}/ssl/ssl.custom
# Check custom settings
if [ ! -e ${setting_dir}/settings.custom ]; then
 clear
 echo "[i] ${setting_dir}/settings.custom does not exist, it is not necesary to apply this patch"
 exit 1
fi
source ${setting_dir}/settings.custom
if [ ! -e ${setting_dir}/settings.custom.rollback ]; then
 cp ${setting_dir}/settings.custom ${setting_dir}/settings.custom.rollback
fi
sed -i 's|^KIUWAN_PORT=.*|KIUWAN_PORT='"${HTTPS_PORT}"'|' ${setting_dir}/settings.custom 
echo -e "# Setting added by script run_change_ToHTTPS.sh \nHTTPS=ON\n" >> ${setting_dir}/settings.custom
echo -e "# Also this script modified KIUWAN_PORT from ${KIUWAN_PORT} to ${HTTPS_PORT}" >> ${setting_dir}/settings.custom
sed -i '/^-p \${HTTPS_PORT}:\${HTTPS_PORT}.*/d' ${setting_dir}/run_kop.sh

# Backup old scripts
cp ${setting_dir}/ssl/run_change_ToHTTPS.sh ${setting_dir}/ssl/run_change_ToHTTPS.sh.bck.${NOW}
cp ${setting_dir}/ssl/run_rollback_HTTPS.sh ${setting_dir}/ssl/run_rollback_HTTPS.sh.BCK.${NOW}

# Copy new scripts
cp ${patch_dir}/../../ssl/run_change_ToHTTPS.sh ${setting_dir}/ssl/run_change_ToHTTPS.sh 
cp ${patch_dir}/../../ssl/run_rollback_HTTPS.sh ${setting_dir}/ssl/run_rollback_HTTPS.sh
clear
echo "[i] Patch apllied sucessfully"
