#!/bin/bash
#
if [ "$0" != "./CreateKey_and_ReqCSR.sh" ]; then
  clear
  echo "[i] Please, this script must be executed without absolute path, excute it as ./CreateKey_and_ReqCSR.sh from its owned directory"
  exit 1
fi
#
# Check ssl custom
if [ ! -e ./ssl.custom ]; then
 clear
 echo "[i] ./ssl.custom does not exist, please"
 echo "[i] copy ssl.tpl as ssl.custom, cp ssl.tpl ssl.custom, then custommize ssl.custom and execute this script again"
 exit 1
fi
source ./ssl.custom
# Check custom settings
if [ ! -e ../settings.custom ]; then
 clear
 echo "[i] ../settings.custom does not exist, please"
 echo "[i] this file is necesary to convert kiuwan on premises to https"
 exit 1
fi
source ../settings.custom

# Create Server key and CRS
openssl req -nodes -newkey rsa:2048 -keyout ./certs/${KIUWAN_HOST}.key -out ./certs/${KIUWAN_HOST}.csr -subj "/C=${SSL_COUNTRY}/ST=${SSL_STATE}/L=${SSL_LOCALITY}/O=${SSL_O}/OU=${SSL_OU}/CN=${KIUWAN_HOST}"
if [ ! "$?" = "0" ]; then
  echo "[i] It has had an error to create private key or CSR file"
  exit 1
fi
#
clear
echo "[i] Copy this file ${KIUWAN_HOST}.csr and send it to your CA to sign it"
echo -e "[i] You will must execute same similar to \n
openssl ca -config openssl.cnf -policy policy_anything -out ${KIUWAN_HOST}.crt -infiles ${KIUWAN_HOST}.csr \n
[i] Copy the signed certificate in ./certs with name ${HOSTNAME}.crt \n
[i] Copy the CA certificate chain in ./certs with name ca.crt \n
[i] VERY IMPORTANT !! the names of certificate files must be exactly like that \n
and execute the following scripts in this order: \n
1. ./TransferFilesToContainer.sh \n
2. ./run_create_Keystore.sh \n
3. ./run_change_ToHTTPS.sh"
