#!/bin/bash
#
if [ "$0" != "./TransferFilesToContainer.sh" ]; then
  clear
  echo "[i] Please, this script must be executed without absolute path, excute it as ./TransferFilesToContainer.sh from its owned directory"
  exit 1
fi
#
# Check ssl custom
if [ ! -e ./ssl.custom ]; then
 clear
 echo "[i] ./ssl.custom does not exist, please"
 echo "[i] copy ssl.tpl as ssl.custom, cp ssl.tpl ssl.custom, then custommize ssl.custom and execute this script again"
 exit 1
fi
source ./ssl.custom
# Check custom settings
if [ ! -e ../settings.custom ]; then
 clear
 echo "[i] ../settings.custom does not exist, please"
 echo "[i] this file is necesary to use ths script"
 exit 1
fi
source ../settings.custom
if [ ! -e ./certs/${KIUWAN_HOST}.key -o ! -e ./certs/${KIUWAN_HOST}.crt -o ! -e ./certs/ca.crt ]; then
 echo "[i] The ./certs/${KIUWAN_HOST}.key or ./certs/${KIUWAN_HOST}.crt or ./certs/ca.crt does not exist"
 echo "[i] Please, fix this issue and run this script again"
 exit 1
fi
HAY_SSL_DIR=`docker exec -it ${KIUWAN_HOST} [ -e ${KIUWAN_VOL}/configurations/ssl ] && echo 'true' || echo 'false'`
if [ "${HAY_SSL_DIR}" = "false" ]; then
 docker exec -it ${KIUWAN_HOST} mkdir -p ${KIUWAN_VOL}/configurations/ssl
fi
docker cp ./certs/${KIUWAN_HOST}.key ${KIUWAN_HOST}:/${KIUWAN_VOL}/configurations/ssl/. 
docker cp ./certs/${KIUWAN_HOST}.crt ${KIUWAN_HOST}:/${KIUWAN_VOL}/configurations/ssl/.
docker cp ./certs/ca.crt ${KIUWAN_HOST}:/${KIUWAN_VOL}/configurations/ssl/.
docker exec -it ${KIUWAN_HOST} chown -R ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/configurations/ssl
docker exec -it ${KIUWAN_HOST} chmod 400 ${KIUWAN_VOL}/configurations/ssl/${KIUWAN_HOST}.key ${KIUWAN_VOL}/configurations/ssl/${KIUWAN_HOST}.crt ${KIUWAN_VOL}/configurations/ssl/ca.crt    
# Transfer tools
JAVA_VERSION=`grep "ARG JAVA_VERSION=" ../Dockerfile | awk -F "=" '{print $2}'`

# create_Keystore.sh
docker cp ./create_Keystore.tpl ${KIUWAN_HOST}:/${KIUWAN_VOL}/koptools/create_Keystore.sh
docker exec -it ${KIUWAN_HOST} chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/koptools/create_Keystore.sh
docker exec -it ${KIUWAN_HOST} chmod 750 ${KIUWAN_VOL}/koptools/create_Keystore.sh
docker exec -it ${KIUWAN_HOST} sed -i 's|^JAVA_VERSION=|JAVA_VERSION='"${JAVA_VERSION}"'|' ${KIUWAN_VOL}/koptools/create_Keystore.sh 
docker exec -it ${KIUWAN_HOST} sed -i 's|^KIUWAN_VOL=|KIUWAN_VOL='"${KIUWAN_VOL}"'|' ${KIUWAN_VOL}/koptools/create_Keystore.sh 
docker exec -it ${KIUWAN_HOST} sed -i 's|^KIUWAN_HOST=|KIUWAN_HOST='"${KIUWAN_HOST}"'|' ${KIUWAN_VOL}/koptools/create_Keystore.sh 
docker exec -it ${KIUWAN_HOST} sed -i 's|^KIUWAN_USER=|KIUWAN_USER='"${KIUWAN_USER}"'|' ${KIUWAN_VOL}/koptools/create_Keystore.sh 
docker exec -it ${KIUWAN_HOST} sed -i 's|^KIUWAN_GROUP=|KIUWAN_GROUP='"${KIUWAN_GROUP}"'|' ${KIUWAN_VOL}/koptools/create_Keystore.sh 
docker exec -it ${KIUWAN_HOST} sed -i 's|^SSL_KS_PWD=|SSL_KS_PWD='"${SSL_KS_PWD}"'|' ${KIUWAN_VOL}/koptools/create_Keystore.sh

# change_ToHTTPS.sh
docker cp ./change_ToHTTPS.tpl ${KIUWAN_HOST}:/${KIUWAN_VOL}/koptools/change_ToHTTPS.sh
docker exec -it ${KIUWAN_HOST} chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/koptools/change_ToHTTPS.sh
docker exec -it ${KIUWAN_HOST} chmod 750 ${KIUWAN_VOL}/koptools/change_ToHTTPS.sh 
docker exec -it ${KIUWAN_HOST} sed -i 's|^JAVA_VERSION=|JAVA_VERSION='"${JAVA_VERSION}"'|' ${KIUWAN_VOL}/koptools/change_ToHTTPS.sh 
docker exec -it ${KIUWAN_HOST} sed -i 's|^KIUWAN_VOL=|KIUWAN_VOL='"${KIUWAN_VOL}"'|' ${KIUWAN_VOL}/koptools/change_ToHTTPS.sh
docker exec -it ${KIUWAN_HOST} sed -i 's|^KIUWAN_USER=|KIUWAN_USER='"${KIUWAN_USER}"'|' ${KIUWAN_VOL}/koptools/change_ToHTTPS.sh
docker exec -it ${KIUWAN_HOST} sed -i 's|^KIUWAN_GROUP=|KIUWAN_GROUP='"${KIUWAN_GROUP}"'|' ${KIUWAN_VOL}/koptools/change_ToHTTPS.sh
docker exec -it ${KIUWAN_HOST} sed -i 's|^KIUWAN_HOST=|KIUWAN_HOST='"${KIUWAN_HOST}"'|' ${KIUWAN_VOL}/koptools/change_ToHTTPS.sh 
docker exec -it ${KIUWAN_HOST} sed -i 's|^KIUWAN_PORT=|KIUWAN_PORT='"${KIUWAN_PORT}"'|' ${KIUWAN_VOL}/koptools/change_ToHTTPS.sh 
docker exec -it ${KIUWAN_HOST} sed -i 's|^HTTPS_PORT=|HTTPS_PORT='"${HTTPS_PORT}"'|' ${KIUWAN_VOL}/koptools/change_ToHTTPS.sh 
docker exec -it ${KIUWAN_HOST} sed -i 's|^SSL_KS_PWD=|SSL_KS_PWD='"${SSL_KS_PWD}"'|' ${KIUWAN_VOL}/koptools/change_ToHTTPS.sh
# rollback_HTTPS.sh
docker cp ./rollback_HTTPS.tpl ${KIUWAN_HOST}:/${KIUWAN_VOL}/koptools/rollback_HTTPS.sh
docker exec -it ${KIUWAN_HOST} chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/koptools/rollback_HTTPS.sh
docker exec -it ${KIUWAN_HOST} chmod 750 ${KIUWAN_VOL}/koptools/rollback_HTTPS.sh 
docker exec -it ${KIUWAN_HOST} sed -i 's|^KIUWAN_VOL=|KIUWAN_VOL='"${KIUWAN_VOL}"'|' ${KIUWAN_VOL}/koptools/rollback_HTTPS.sh
