#!/bin/bash
JAVA_VERSION=
KIUWAN_VOL=
KIUWAN_USER=
KIUWAN_GROUP=
KIUWAN_HOST=
KIUWAN_PORT=
HTTPS_PORT=
SSL_KS_PWD=
#
NOW=`date +%Y-%m-%d_%Hh%m%Ss`
#
if [ ! -e ${KIUWAN_VOL}/configurations/ssl ]; then 
 echo "[i] ${KIUWAN_VOL}/configurations/ssl must be exist"
 echo "[i] Had you execute TransferFileToContainer.sh script previously?"
 exit 1
fi
SSL_DIR=${KIUWAN_VOL}/configurations/ssl
if [ "${HTTPS_PORT}" = "443" ]; then
 KIUWAN_ROOT_URL="https://${KIUWAN_HOST}"
else
 KIUWAN_ROOT_URL="https://${KIUWAN_HOST}:${HTTPS_PORT}"
fi

if [ ! -e ${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml.http.rollback ]; then
  cp -pf ${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml ${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml.http.rollback
  chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml.http.rollback
fi

# Wildfly config
xmlstarlet ed -L -N x1="urn:jboss:domain:4.0" \
-s //x1:security-realms -t elem -n security-realm -v '' \
-a //security-realm -t attr -n name -v 'UndertowRealm' \
-s //security-realm -t elem -n server-identities -v "" \
-s //server-identities -t elem -n ssl -v "" \
-s //ssl -t elem -n keystore -v "" \
-a //keystore -t attr -n path -v "${SSL_DIR}/server.keystore.jks" \
-a //keystore -t attr -n keystore-password -v "${SSL_KS_PWD}" \
${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml

xmlstarlet ed -L -N x1="urn:jboss:domain:undertow:3.0" \
-s //x1:server -t elem -n https-listener -v '' \
-a //https-listener -t attr -n name -v 'default' \
-a //https-listener -t attr -n socket-binding -v 'https' \
-a //https-listener -t attr -n security-realm -v 'UndertowRealm' \
-a //https-listener -t attr -n max-parameters -v '4000' \
-a //https-listener -t attr -n max-post-size -v '2147483648' \
${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml

xmlstarlet ed -L -N x1="urn:jboss:domain:undertow:3.0" \
-d //x1:http-listener \
${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml

xmlstarlet ed -L -N x1="urn:jboss:domain:4.0" \
-u "x1:server/x1:management/x1:management-interfaces/x1:http-interface/x1:socket-binding/@http" -v 'management-https' \
${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml

xmlstarlet ed -L -N x1="urn:jboss:domain:4.0" \
-d "x1:server/x1:socket-binding-group/x1:socket-binding[@name='management-http']" \
${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml

xmlstarlet ed -L -N x1="urn:jboss:domain:4.0" \
-d "x1:server/x1:socket-binding-group/x1:socket-binding[@name='http']" \
${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml

xmlstarlet ed -L -N x1="urn:jboss:domain:4.0" \
-u "x1:server/x1:socket-binding-group/x1:socket-binding[@name='https']/@port" -v '${jboss.https.port:'"${HTTPS_PORT}"'}' \
${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml

xmlstarlet ed -L -N x1="urn:jboss:domain:undertow:3.0" \
-s //x1:host -t elem -n access-log -v '' \
-a //access-log -t attr -n pattern -v 'common' \
-a //access-log -t attr -n directory -v "${KIUWAN_VOL}/logs/wildfly" \
-a //access-log -t attr -n prefix -v 'access' \
-a //access-log -t attr -n suffix -v '.log' \
${KIUWAN_VOL}/configurations/wildfly/standalone/configuration/standalone.xml

# Kiuwan config
if [ ! -e ${KIUWAN_VOL}/deployconfig/kiuwan/configuration/WEB-INF/classes/config/application.properties.http.rollback ]; then
  cp -pf ${KIUWAN_VOL}/deployconfig/kiuwan/configuration/WEB-INF/classes/config/application.properties ${KIUWAN_VOL}/deployconfig/kiuwan/configuration/WEB-INF/classes/config/application.properties.http.rollback
  chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/deployconfig/kiuwan/configuration/WEB-INF/classes/config/application.properties.http.rollback
fi
 sed -i 's|http://'"${KIUWAN_HOST}:${KIUWAN_PORT}"'|'"${KIUWAN_ROOT_URL}"'|' \
 ${KIUWAN_VOL}/deployconfig/kiuwan/configuration/WEB-INF/classes/config/application.properties
 
# KLA
KIUWAN_URL="${KIUWAN_ROOT_URL}/saas"
KIUWAN_API_URL="${KIUWAN_URL}/rest/v1"
if [ ! -e ${KIUWAN_VOL}/welcome-content/pub/analyzer/KiuwanLocalAnalyzer.zip.http.rollback ]; then
 cp -pf ${KIUWAN_VOL}/welcome-content/pub/analyzer/KiuwanLocalAnalyzer.zip ${KIUWAN_VOL}/welcome-content/pub/analyzer/KiuwanLocalAnalyzer.zip.http.rollback
 chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/welcome-content/pub/analyzer/KiuwanLocalAnalyzer.zip.http.rollback
fi
cp ${KIUWAN_VOL}/welcome-content/pub/analyzer/KiuwanLocalAnalyzer.zip  .
unzip ${KIUWAN_VOL}/welcome-content/pub/analyzer/KiuwanLocalAnalyzer.zip
sed -i 's|^url=.*|url='"${KIUWAN_URL}"'|g' KiuwanLocalAnalyzer/conf/agent.properties
sed -i 's|^rest.services.url=.*|rest.services.url='"${KIUWAN_API_URL}"'|g' KiuwanLocalAnalyzer/conf/agent.properties
sed -i 's|^download.url=.*|download.url='"${KIUWAN_ROOT_URL}"'/pub/analyzer|g' KiuwanLocalAnalyzer/conf/agent.properties
/opt/jdk1.${JAVA_VERSION}/bin/jar -uf KiuwanLocalAnalyzer.zip KiuwanLocalAnalyzer/conf/agent.properties
cp KiuwanLocalAnalyzer.zip ${KIUWAN_VOL}/welcome-content/pub/analyzer/KiuwanLocalAnalyzer.zip																				
rm -rf KiuwanLocalAnalyzer
rm -r KiuwanLocalAnalyzer.zip

# Change deployKiuwan.sh
if [ ! -e ${KIUWAN_VOL}/koptools/deployKiuwan.sh.http.rollback ]; then
 cp -pf ${KIUWAN_VOL}/koptools/deployKiuwan.sh ${KIUWAN_VOL}/koptools/deployKiuwan.sh.http.rollback
 chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/koptools/deployKiuwan.sh.http.rollback
fi
sed -i 's|^KIUWAN_ROOT_URL=.*|KIUWAN_ROOT_URL='"${KIUWAN_ROOT_URL}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh

# index.html
if [ ! -e ${KIUWAN_VOL}/welcome-content/index.html.http.rollback ]; then
 cp -pf ${KIUWAN_VOL}/welcome-content/index.html ${KIUWAN_VOL}/welcome-content/index.html.http.rollback
 chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/welcome-content/index.html.http.rollback
fi
sed -i 's|http://'"${KIUWAN_HOST}:${KIUWAN_PORT}"'|'"${KIUWAN_ROOT_URL}"'|' \
${KIUWAN_VOL}/welcome-content/index.html

# authbind
# 
if [ ! ${KIUWAN_USER} = 'root' -a ${HTTPS_PORT} -lt 1024 ]; then
 if [ ! -e ${KIUWAN_VOL}/configurations/etc/authbind.rollback ]; then
  cp -rpf  ${KIUWAN_VOL}/configurations/etc/authbind ${KIUWAN_VOL}/configurations/etc/authbind.rollback
  chown -R ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/configurations/etc/authbind.rollback
 fi
 touch ${KIUWAN_VOL}/configurations/etc/authbind/byport/${HTTPS_PORT}
 chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/configurations/etc/authbind/byport/${HTTPS_PORT}
 chmod 777 ${KIUWAN_VOL}/configurations/etc/authbind/byport/${HTTPS_PORT}
 if [ ! -e ${KIUWAN_VOL}/configurations/wildfly/bin/standalone.sh.rollback ]; then
  cp -pf ${KIUWAN_VOL}/configurations/wildfly/bin/standalone.sh ${KIUWAN_VOL}/configurations/wildfly/bin/standalone.sh.rollback
  chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/configurations/wildfly/bin/standalone.sh.rollback
 fi
 # added by startup.sh ?
 ARE_THERE_AUTHBIND=`grep "java_authbind.sh" ${KIUWAN_VOL}/configurations/wildfly/bin/standalone.sh`
 if [ "${ARE_THERE_AUTHBIND}" = "" ]; then
  sed -i 's|^while true; do.*|while true; do\n   JAVA=$JAVA_HOME/bin/java_authbind.sh\n|' ${KIUWAN_VOL}/configurations/wildfly/bin/standalone.sh
 fi
fi
