#!/bin/bash
#
JAVA_VERSION=
KIUWAN_VOL=
KIUWAN_HOST=
KIUWAN_USER=
KIUWAN_GROUP=
#
SSL_KS_PWD=
#
NOW=`date +%Y-%m-%d_%Hh%m%Ss`
#
if [ ! -e ${KIUWAN_VOL}/configurations/ssl ]; then 
 echo "[i] ${KIUWAN_VOL}/configurations/ssl must be exist"
 echo "[i] Had you execute TransferFileToContainer.sh script previously?"
 exit 1
fi
SSL_DIR=${KIUWAN_VOL}/configurations/ssl
#
if [ -e ${SSL_DIR}/server.keystore.p12 ]; then
 rm -f  ${SSL_DIR}/server.keystore.p12
fi
if [ ! -e ${SSL_DIR}/${KIUWAN_HOST}.crt -o ! -e ${SSL_DIR}/${KIUWAN_HOST}.key ]; then
 echo "[i] I can not find ca.crt or ${KIUWAN_HOST}.crt or ${SSL_DIR}/${KIUWAN_HOST}.key in ${SSL_DIR}"
 echo "[i] Had you execute TransferFileToContainer.sh script previously?"
 exit 1
fi
openssl pkcs12 -export -chain -CAfile ${SSL_DIR}/ca.crt -in ${SSL_DIR}/${KIUWAN_HOST}.crt \
-inkey ${SSL_DIR}/${KIUWAN_HOST}.key -out ${SSL_DIR}/server.keystore.p12 -password pass:${SSL_KS_PWD} \
-name "${KIUWAN_HOST}"

if [ ! "$?" = "0" ]; then
  echo "[i] It has had an error to create keystore file ${SSL_DIR}/server.keystore.p12"
  exit 1
fi
echo "[i] keystore ${SSL_DIR}/server.keystore.p12 successfully created"
echo "[i] We are going to convert this keystore ${SSL_DIR}/server.keystore.p12 to a jks keystore ${SSL_DIR}/server.keystore.jks"
if [ -e ${SSL_DIR}/server.keystore.jks ]; then
 rm -f  ${SSL_DIR}/server.keystore.jks
fi
/opt/jdk1.${JAVA_VERSION}/bin/keytool -importkeystore -srckeystore ${SSL_DIR}/server.keystore.p12 -srcstorepass ${SSL_KS_PWD} -srcalias ${KIUWAN_HOST} \
 -destkeystore ${SSL_DIR}/server.keystore.jks -deststorepass  ${SSL_KS_PWD} -srcstoretype pkcs12 -destalias ${KIUWAN_HOST}
if [ ! "$?" = "0" ]; then
  echo "[i] It has had an error to convert keystore file ${SSL_DIR}/server.keystore.p12 to ${SSL_DIR}/server.keystore.jks"
  exit 1
fi
echo "[i] keystore ${SSL_DIR}/server.keystore.jks created succesfully"
rm -f ${SSL_DIR}/server.keystore.p12 
rm -f ${SSL_DIR}/${KIUWAN_HOST}.key 
# rm -f ${SSL_DIR}/${KIUWAN_HOST}.crt ${SSL_DIR}/ca.crt 
chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${SSL_DIR}/server.keystore.jks
chmod 400 ${SSL_DIR}/server.keystore.jks   
exit 0
