#!/bin/bash
#
if [ "$0" != "./run_change_ToHTTPS.sh" ]; then
  clear
  echo "[i] Please, this script must be executed without absolute path, excute it as ./run_change_ToHTTPS.sh from its owned directory"
  exit 1
fi
NOW=`date +%Y-%m-%d_%Hh%m%Ss`
# Check ssl custom
if [ ! -e ./ssl.custom ]; then
 clear
 echo "[i] ./ssl.custom does not exist, please"
 echo "[i] copy ssl.tpl as ssl.custom, cp ssl.tpl ssl.custom, then custommize ssl.custom and execute this script again"
 exit 1
fi
source ./ssl.custom
# Check custom settings
if [ ! -e ../settings.custom ]; then
 clear
 echo "[i] ../settings.custom does not exist, please"
 echo "[i] this file is necesary to use ths script"
 exit 1
fi
source ../settings.custom
STATUS=`docker exec -it ${KIUWAN_HOST} supervisorctl status wildfly | awk '{print $2}'`
if [ "${STATUS}" = "RUNNING" ]; then
	docker exec -it ${KIUWAN_HOST} supervisorctl stop wildfly
fi
docker exec -it ${KIUWAN_HOST} ${KIUWAN_VOL}/koptools/change_ToHTTPS.sh
if [ ! "$?" = "0" ]; then
  echo "[i] It has had an error to change http protocol"
  exit 1
fi
docker exec -it ${KIUWAN_HOST} cp ${KIUWAN_VOL}/release/current.version ${KIUWAN_VOL}/release/todeploy.version
docker exec -it ${KIUWAN_HOST} ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} mv ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log.${NOW}
# docker exec -it ${KIUWAN_HOST} supervisorctl start wildfly
# sleep 10
# docker exec -it ${KIUWAN_HOST} /bin/sh -c "/usr/bin/tail -n -1 -f ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log | { /bin/sed '/started in/ q' && /usr/bin/killall tail ;}"
if [ ! -e ../run_kop.sh.rollback ]; then
 cp ../run_kop.sh ../run_kop.sh.rollback 
fi
if [ ! -e ../settings.custom.rollback ]; then
 cp ../settings.custom ../settings.custom.rollback
fi
sed -i 's|^KIUWAN_PORT=.*|KIUWAN_PORT='"${HTTPS_PORT}"'|' ../settings.custom 
if [ -z ${HTTPS+x} ]; 
 # HTTPS not exists in settings.custom, add...
 then echo -e "# Setting added by script run_change_ToHTTPS.sh \nHTTPS=ON\n" >> ../settings.custom
 # HTTPS exists, modify...
 else sed -i 's|^HTTPS=.*|HTTPS=ON|' ../settings.custom
fi
echo -e "# Also this script modified KIUWAN_PORT from ${KIUWAN_PORT} to ${HTTPS_PORT}" >> ../settings.custom 
docker stop ${KIUWAN_HOST}
sleep 10
cd ..
. ./run_kop.sh
