#!/bin/bash
#
NOW=`date +%Y-%m-%d_%Hh%m%Ss`

if [ "$0" != "./run_rollback_HTTPS.sh" ]; then
  clear
  echo "[i] Please, this script must be executed without absolute path, excute it as ./run_rollback_HTTPS.sh from its owned directory"
  exit 1
fi
# Check custom settings
if [ ! -e ../settings.custom ]; then
 clear
 echo "[i] ../settings.custom does not exist, please"
 echo "[i] this file is necesary to use ths script"
 exit 1
fi
source ../settings.custom
STATUS=`docker exec -it ${KIUWAN_HOST} supervisorctl status wildfly | awk '{print $2}'`
if [ "${STATUS}" = "RUNNING" ]; then
	docker exec -it ${KIUWAN_HOST} supervisorctl stop wildfly
fi
docker exec -it ${KIUWAN_HOST} ${KIUWAN_VOL}/koptools/rollback_HTTPS.sh
if [ ! "$?" = "0" ]; then
  echo "[i] It has had an error to do rollback to http protocol"
  exit 1
fi
if [ -e ../run_kop.sh.rollback ]; then
 cp ../run_kop.sh.rollback ../run_kop.sh
fi
if [ -e ../settings.custom.rollback ]; then
 cp ../settings.custom.rollback ../settings.custom
fi
docker exec -it ${KIUWAN_HOST} cp ${KIUWAN_VOL}/release/current.version ${KIUWAN_VOL}/release/todeploy.version 
docker exec -it ${KIUWAN_HOST} ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} mv ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log.${NOW}
docker exec -it ${KIUWAN_HOST} supervisorctl start wildfly
sleep 10
docker exec -it ${KIUWAN_HOST} /bin/sh -c "/usr/bin/tail -n -1 -f ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log | { /bin/sed '/started in/ q' && /usr/bin/killall tail ;}"
