#!/bin/bash
set -e

KIUWAN_VOL=
MYSQL_SERVER=
MYSQL_PORT=
MYSQL_CONNECT_STRING=
KIUWAN_MYSQL_USER=
KIUWAN_MYSQL_PWD=
MYSQL_ROOT_PWD=
MYSQL_JCONNECTOR_VERSION=
KIUWAN_USER=
KIUWAN_GROUP=
APPS_VERSION=
KIUWAN_EMAIL_ADMIN_ACCOUNT=
KIUWAN_PORT=
#
DIR_DEPLOYMENTS=deployments
DIR_APP_TO_DEPLOY=saas.war
#
init_kiuwanvol () {
 echo "[i] Creating kiuwan_vol in persistent volume"
 rm -rf $KIUWAN_VOL/./*
 
 # Kiuwan app
 mkdir -p $KIUWAN_VOL/configq1
 mkdir -p $KIUWAN_VOL/deployconfig
 mkdir -p $KIUWAN_VOL/definitions
 mkdir -p $KIUWAN_VOL/insight
 mkdir -p $KIUWAN_VOL/insight/temp/nvddb/3.0/backup 
 mkdir -p $KIUWAN_VOL/insight/temp/nvddb/3.0/dbSync 
 mkdir -p $KIUWAN_VOL/KiuwanCentralWorkingDirectory
 mkdir -p $KIUWAN_VOL/KiuwanCentralWorkingDirectory/sources 
 mkdir -p $KIUWAN_VOL/license 
 mkdir -p $KIUWAN_VOL/repos 
 mkdir -p $KIUWAN_VOL/repos/kiuwanSourceCodeRepository 
 mkdir -p $KIUWAN_VOL/$DIR_DEPLOYMENTS
 mkdir -p $KIUWAN_VOL/release
 mkdir -p $KIUWAN_VOL/back_before_deploy 
 mkdir -p $KIUWAN_VOL/koptools
 
 # Dirs commons
 mkdir -p $KIUWAN_VOL/configurations
 mkdir -p $KIUWAN_VOL/logs

 # Config kiuwan
 cp -r /root/kiuwan/tmp/definitions $KIUWAN_VOL/.
 cp /root/kiuwan/tmp/license/* $KIUWAN_VOL/license/.
 cp /root/kiuwan/tmp/configq1/* $KIUWAN_VOL/configq1/.    	
 cp -r /root/kiuwan/tmp/deployconfig/kiuwan $KIUWAN_VOL/deployconfig/.
 cp -r /root/kiuwan/tmp/welcome-content $KIUWAN_VOL/.
 cp /root/kiuwan/tmp/deployKiuwan.sh $KIUWAN_VOL/koptools/.
 cp /root/kiuwan/tmp/redeployKiuwan.sh $KIUWAN_VOL/koptools/.
 cp /root/kiuwan/tmp/cron_redis.sh $KIUWAN_VOL/koptools/.
 cp /root/kiuwan/tmp/optimyth-cinc-distribution-* $KIUWAN_VOL/release/.
 cp /root/kiuwan/tmp/current.version $KIUWAN_VOL/release/todeploy.version


 # Config mysql	
 mkdir -p $KIUWAN_VOL/configurations/etc/mysql/mysql.conf.d
 mkdir -p $KIUWAN_VOL/logs/mysql
 cp /etc/mysql/mysql.conf.d/mysqld.cnf.init $KIUWAN_VOL/configurations/etc/mysql/mysql.conf.d/mysqld.cnf

 # Config wildfly	
 mkdir -p $KIUWAN_VOL/configurations/wildfly/standalone/configuration 
 mkdir -p $KIUWAN_VOL/configurations/wildfly/bin
 cp /opt/wildfly-${APPS_VERSION}/standalone/configuration/standalone.xml.init $KIUWAN_VOL/configurations/wildfly/standalone/configuration/standalone.xml  
 cp /opt/wildfly-${APPS_VERSION}/bin/standalone.conf.init $KIUWAN_VOL/configurations/wildfly/bin/standalone.conf
 mkdir -p $KIUWAN_VOL/logs/wildfly 
# Preparte to convert to SSL
cp /opt/wildfly-${APPS_VERSION}/bin/standalone.sh.init $KIUWAN_VOL/configurations/wildfly/bin/standalone.sh
cp -r /etc/authbind.init $KIUWAN_VOL/configurations/etc/authbind
 
 # Config redis
 mkdir -p $KIUWAN_VOL/redis
 mkdir -p $KIUWAN_VOL/configurations/etc/redis
 cp /etc/redis/redis.conf.init $KIUWAN_VOL/configurations/etc/redis/redis.conf
 mkdir -p $KIUWAN_VOL/logs/redis

 # Config mongodb
 mkdir -p $KIUWAN_VOL/configurations/etc
 cp /etc/mongod.conf.init  $KIUWAN_VOL/configurations/etc/mongod.conf 
 mkdir -p $KIUWAN_VOL/mongodb
 mkdir -p $KIUWAN_VOL/logs/mongodb 

 # Config supervisor
 mkdir -p $KIUWAN_VOL/logs/supervisor
 mkdir -p $KIUWAN_VOL/configurations/etc/supervisor/conf.d
 cp /etc/supervisor/conf.d.init/*.conf  $KIUWAN_VOL/configurations/etc/supervisor/conf.d/.

 echo "[i] Creating kiuwan_vol in persistent volume finished"
 chown -R $KIUWAN_USER:$KIUWAN_GROUP $KIUWAN_VOL	
}

init_kiuwandb () {
 echo "[i] MySql environment initiated"
 if [ -e $KIUWAN_VOL/mysql ]; then
  rm -rf $KIUWAN_VOL/mysql
 fi
 # mysql 5.6 
 mysql_install_db --user=$KIUWAN_USER --defaults-file=/etc/mysql/my.cnf --basedir=/usr --datadir=$KIUWAN_VOL/mysql
 # mysql 5.7
 # mysqld  --defaults-file=/etc/mysql/my.cnf --initialize-insecure --user=mysql --datadir=$KIUWAN_VOL/mysql# cp -rpf /var/lib/mysql $KIUWAN_VOL/.
 chown -R $KIUWAN_USER:$KIUWAN_GROUP $KIUWAN_VOL/mysql
 # service mysql start
 mysqld_safe --defaults-file=/etc/mysql/my.cnf --user=$KIUWAN_USER --basedir=/usr --datadir=$KIUWAN_VOL/mysql &
 CONTADOR=0
 while [ ! -e /var/run/mysqld/mysqld.sock -a ${CONTADOR} -le 30 ]; do
   sleep 1
   let CONTADOR=CONTADOR+1
 done 
 if [ ! -e /var/run/mysqld/mysqld.sock ]; then
  echo "[i] Mysql can not be initiated"
  exit 1
 fi																										
 echo "[i] Setting passwod $MYSQL_ROOT_PWD to root user in mysql"
 mysqladmin -uroot password $MYSQL_ROOT_PWD
 echo "[i] Setting connections from all host to root user"
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "GRANT ALL PRIVILEGES ON *.* TO 'root'@'%' IDENTIFIED BY '${MYSQL_ROOT_PWD}' WITH GRANT OPTION; FLUSH PRIVILEGES;" > /dev/null 2>&1
 echo "[i] Deleting test database"
 # Comentar la siguente linea para mysql 5.7
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "drop database test;" > /dev/null 2>&1
 echo "[i] Deleting anonymous users"
 # Comentar la siguente linea para mysql 5.7
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "drop user ''@'localhost';" > /dev/null 2>&1
 # Comentar la siguente linea para mysql 5.7
 CONTAINER_ID=`mysql -s --user=root --password=${MYSQL_ROOT_PWD} mysql -e "select host from user where user='';"`
 # Comentar la siguente linea para mysql 5.7
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "drop user ''@'${CONTAINER_ID}';" > /dev/null 2>&1
 echo "[i] Creating Kiuwan schemas and kiuwan database user"
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "create database if not exists opt_activity CHARACTER SET utf8 COLLATE utf8_unicode_ci;" > /dev/null 2>&1
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "create database if not exists opt_cinc CHARACTER SET utf8 COLLATE utf8_unicode_ci;" > /dev/null 2>&1
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "create database if not exists opt_metamodel CHARACTER SET utf8 COLLATE utf8_unicode_ci;" > /dev/null 2>&1
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "create database if not exists opt_qmm CHARACTER SET utf8 COLLATE utf8_unicode_ci;" > /dev/null 2>&1		
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "create database if not exists opt_transaction CHARACTER SET utf8 COLLATE utf8_unicode_ci;" > /dev/null 2>&1
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "create database if not exists opt_insight CHARACTER SET utf8 COLLATE utf8_unicode_ci;" > /dev/null 2>&1	
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "create user '$KIUWAN_MYSQL_USER'@'localhost' identified by '$KIUWAN_MYSQL_PWD';" > /dev/null 2>&1
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "create user '$KIUWAN_MYSQL_USER'@'%' identified by '$KIUWAN_MYSQL_PWD';" > /dev/null 2>&1
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "grant all privileges on \`opt_%\`.* to '$KIUWAN_MYSQL_USER'@'localhost' identified by '$KIUWAN_MYSQL_PWD';" > /dev/null 2>&1
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "grant all privileges on \`opt_%\`.* to '$KIUWAN_MYSQL_USER'@'%' identified by '$KIUWAN_MYSQL_PWD';" > /dev/null 2>&1
 mysql --user=root --password=$MYSQL_ROOT_PWD -e "flush privileges;" > /dev/null 2>&1
 echo "[i] MySql environment finished"
}

init_kiuwan_schemas () {
 echo "[i] Create Kiuwan schemas initiated"
 chown -R $KIUWAN_USER:$KIUWAN_GROUP $KIUWAN_VOL/release/installation
 # cp /root/kiuwan/tmp/mysql-connector-java-${MYSQL_JCONNECTOR_VERSION}-bin.jar $KIUWAN_VOL/release/installation/lib/.
 # Se ha copiado en el proceso deployKiuwan
 sed -i -e 's|^db.connection.host=.*|db.connection.host='"${MYSQL_SERVER}"'|' $KIUWAN_VOL/release/installation/conf/db-connection.properties
 sed -i -e 's|^db.connection.port=.*|db.connection.port='"${MYSQL_PORT}"'|' $KIUWAN_VOL/release/installation/conf/db-connection.properties
 sed -i -e 's|KIUWAN_MYSQL_USER|'"${KIUWAN_MYSQL_USER}"'|g' $KIUWAN_VOL/release/installation/conf/db-connection.properties
 sed -i -e 's|KIUWAN_MYSQL_PWD|'"${KIUWAN_MYSQL_PWD}"'|g' $KIUWAN_VOL/release/installation/conf/db-connection.properties
 /opt/apache-ant-*/bin/ant -buildfile $KIUWAN_VOL/release/installation/install.xml
 echo "[i] Create database finished"
 echo "[i] Qmm upgrade..."
 mysql --user=$KIUWAN_MYSQL_USER --password=$KIUWAN_MYSQL_PWD -e "UPDATE opt_cinc.OPT_EMAIL SET emailAddress = '$KIUWAN_EMAIL_ADMIN_ACCOUNT';" > /dev/null 2>&1 	
 mysql --user=$KIUWAN_MYSQL_USER --password=$KIUWAN_MYSQL_PWD -e "UPDATE opt_cinc.INFRA_TENANT_METADATA SET connectionUrls = '$MYSQL_CONNECT_STRING';" > /dev/null 2>&1
 
 /opt/apache-ant-*/bin/ant -buildfile $KIUWAN_VOL/release/installation/upgrade_qmm.xml -Dkiuwanvol.dir=$KIUWAN_VOL -Drelease.dir=$KIUWAN_VOL/release -Ddefinitions.dir=$KIUWAN_VOL/definitions
 echo "[i] Qmm upgrade finished"
 killall mysqld > /dev/null 2>&1
 echo "[i] Create Kiuwan schemas finished"
}

copy_deployconfig_to_start () {
 # Copy configuration from persistent volume every new start of container
 cp -r $KIUWAN_VOL/deployconfig/kiuwan/configuration/* $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY/.
 chown -R $KIUWAN_USER:$KIUWAN_GROUP $KIUWAN_VOL/$DIR_DEPLOYMENTS/$DIR_APP_TO_DEPLOY
} 
port_http_less_1024 () 
{
  if [ ! ${KIUWAN_USER} = 'root' -a ${KIUWAN_PORT} -lt 1024 ]; then
   touch ${KIUWAN_VOL}/configurations/etc/authbind/byport/${KIUWAN_PORT}
   chown ${KIUWAN_USER}:${KIUWAN_GROUP} ${KIUWAN_VOL}/configurations/etc/authbind/byport/${KIUWAN_PORT}
   chmod 777 ${KIUWAN_VOL}/configurations/etc/authbind/byport/${KIUWAN_PORT}
   sed -i 's|^while true; do.*|while true; do\n   JAVA=$JAVA_HOME/bin/java_authbind.sh\n|' \
   ${KIUWAN_VOL}/configurations/wildfly/bin/standalone.sh
  fi
}

# ----
# Main
# ----
case $KIUWAN_FIRST_TIME in
"Y"|"y")
 echo "[i] Init Kiuwan container for first time"
 init_kiuwanvol    
 init_kiuwandb
 $KIUWAN_VOL/koptools/deployKiuwan.sh
 init_kiuwan_schemas
 port_http_less_1024
 mv -f $KIUWAN_VOL/release/todeploy.version $KIUWAN_VOL/release/current.version
 echo "[i] Kiuwan container succesfully created for first time"									
 ;;
*)
 case $START_AND_RUN in
 "Y"|"y")
  copy_deployconfig_to_start
  /usr/bin/supervisord -c /etc/supervisor/supervisord.conf
  ;;
 *)
  # Only openssh, to debug and/or management tasks
  /usr/sbin/sshd -D
  ;;
 esac
 ;;
esac
