#!/bin/bash
#
if [ "$1" = "" -o "$1" != "./updateKiuwanLauncher.sh" ]; then
  clear	
  echo "This scrips can not invocated by itself, it must be called by ${settings_dir}/updates/bin/updateKiuwanLauncher.sh"
  exit
fi
source ${settings_dir}/settings.custom
[ "$HTTPS" = "ON" ] && export PROTOCOL=https || export PROTOCOL=http
#
KIUWAN_DOWNLOAD_URL=`grep "KIUWAN_DOWNLOAD_URL=" ${settings_dir}/Dockerfile | awk -F "=" '{print $2}'`
KIUWAN_DOWNLOAD_URL=`echo $KIUWAN_DOWNLOAD_URL | sed 's|\"||g'`
DIR_RELEASE="${KIUWAN_VOL}/release"
#
NOW=`date +%Y-%m-%d_%Hh%m%Ss`

#
KIUWAN_DISTRIBUTION=`docker exec -it ${KIUWAN_HOST} cat ${DIR_RELEASE}/current.version`
docker exec -it ${KIUWAN_HOST} mv ${DIR_RELEASE}/optimyth-cinc-distribution-${KIUWAN_DISTRIBUTION}.jar ${DIR_RELEASE}/optimyth-cinc-distribution-${KIUWAN_DISTRIBUTION}.jar.${NOW}
docker exec -it ${KIUWAN_HOST} cp ${DIR_RELEASE}/current.version ${DIR_RELEASE}/current.version.${NOW}

docker exec -it ${KIUWAN_HOST} wget --no-check-certificate ${KIUWAN_DOWNLOAD_URL}/current.version -O ${DIR_RELEASE}/todeploy.version
KIUWAN_DISTRIBUTION=`docker exec -it ${KIUWAN_HOST} cat ${DIR_RELEASE}/todeploy.version`
docker exec -it ${KIUWAN_HOST} wget --no-check-certificate ${KIUWAN_DOWNLOAD_URL}/optimyth-cinc-distribution-${KIUWAN_DISTRIBUTION}.jar -N -P ${DIR_RELEASE}/

STATUS=`docker exec -it ${KIUWAN_HOST} supervisorctl status wildfly | awk '{print $2}'`
if [ "${STATUS}" = "RUNNING" ]; then
	docker exec -it ${KIUWAN_HOST} supervisorctl stop wildfly
	sleep 5
fi
STATUS=`docker exec -it ${KIUWAN_HOST} supervisorctl status wildfly | awk '{print $2}'`
if [ ! "${STATUS}" = "STOPPED" ]; then
 echo "[i] Wildfly service isn´t stopped, we can't deploy Kiuwan."
 exit 1
fi
docker exec -it ${KIUWAN_HOST} mv ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log.${NOW}
# copy new deployKiuwan
SCRIPT_PATH=`dirname "$(realpath $0)"`
MYSQL_SERVER=`grep "ARG MYSQL_SERVER=" ${settings_dir}/Dockerfile | awk -F "=" '{print $2}'`
MYSQL_PORT=`grep "ARG MYSQL_PORT=" ${settings_dir}/Dockerfile | awk -F "=" '{print $2}'`
# MYSQL_CONNECT_STRING=`grep "ARG MYSQL_CONNECT_STRING=" ${settings_dir}/Dockerfile | awk -F "=" '{print $2}'`
MYSQL_CONNECT_STRING="${MYSQL_SERVER}:${MYSQL_PORT}"
MYSQL_JCONNECTOR_VERSION=`grep "ARG MYSQL_JCONNECTOR_VERSION=" ${settings_dir}/Dockerfile | awk -F "=" '{print $2}'`
if [ "${KIUWAN_WEBSERVER_HOST}" = "" ]; 
 then export KIUWAN_ROOT_URL=${PROTOCOL}://${KIUWAN_HOST}${KIUWAN_PORT:+":${KIUWAN_PORT}"};
 else export KIUWAN_ROOT_URL=${PROTOCOL}://${KIUWAN_WEBSERVER_HOST}${KIUWAN_WEBSERVER_PORT:+":${KIUWAN_WEBSERVER_PORT}"};
fi
APPS_VERSION=`grep "ARG APPS_VERSION=" ${settings_dir}/Dockerfile | awk -F "=" '{print $2}'`
docker cp $SCRIPT_PATH/../../deployKiuwan.sh ${KIUWAN_HOST}:${KIUWAN_VOL}/koptools/.
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^KIUWAN_VOL=.*|KIUWAN_VOL='"${KIUWAN_VOL}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^MYSQL_SERVER=.*|MYSQL_SERVER='"${MYSQL_SERVER}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^MYSQL_PORT=.*|MYSQL_PORT='"${MYSQL_PORT}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^MYSQL_CONNECT_STRING=.*|MYSQL_CONNECT_STRING='"${MYSQL_CONNECT_STRING}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^KIUWAN_MYSQL_USER=.*|KIUWAN_MYSQL_USER='"${KIUWAN_MYSQL_USER}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^KIUWAN_MYSQL_PWD=.*|KIUWAN_MYSQL_PWD='"${KIUWAN_MYSQL_PWD}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^KIUWAN_ROOT_URL=.*|KIUWAN_ROOT_URL='"${KIUWAN_ROOT_URL}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^APPS_VERSION=.*|APPS_VERSION='"${APPS_VERSION}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^KIUWAN_USER=.*|KIUWAN_USER='"${KIUWAN_USER}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^KIUWAN_GROUP=.*|KIUWAN_GROUP='"${KIUWAN_GROUP}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^MYSQL_JCONNECTOR_VERSION=.*|MYSQL_JCONNECTOR_VERSION='"${MYSQL_JCONNECTOR_VERSION}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
docker exec -it ${KIUWAN_HOST} sed -i -e 's|^KIUWAN_EMAIL_ADMIN_ACCOUNT=.*|KIUWAN_EMAIL_ADMIN_ACCOUNT='"${KIUWAN_EMAIL_ADMIN_ACCOUNT}"'|g' ${KIUWAN_VOL}/koptools/deployKiuwan.sh
# end copy new deployKiuwan
docker exec -it ${KIUWAN_HOST} ${KIUWAN_VOL}/koptools/deployKiuwan.sh
echo "[i] Upgrade database"
ANT_RESULT=`docker exec -it ${KIUWAN_HOST} /bin/sh -c "/opt/apache-ant-*/bin/ant -buildfile $KIUWAN_VOL/release/installation/upgrade_database.xml -Dkiuwanvol.dir=$KIUWAN_VOL -Drelease.dir=$KIUWAN_VOL/release -Dcurrent.version.file=${DIR_RELEASE}/current.version -Dtarget.version.file=${DIR_RELEASE}/todeploy.version"`
echo "$ANT_RESULT"
if [[ ${ANT_RESULT} == *"Build failed"* || ${ANT_RESULT} == *"BUILD FAILED"* ]]; then
	echo "[w] Error executing upgrade database buildfile, please contact with kiuwan support"
	exit 1
fi
echo "[i] Upgrade data"
ANT_RESULT=`docker exec -it ${KIUWAN_HOST} /bin/sh -c "/opt/apache-ant-*/bin/ant -buildfile $KIUWAN_VOL/release/installation/upgrade_data.xml -Dkiuwanvol.dir=$KIUWAN_VOL -Drelease.dir=$KIUWAN_VOL/release -Dcurrent.version.file=${DIR_RELEASE}/current.version -Dtarget.version.file=${DIR_RELEASE}/todeploy.version"`
echo "$ANT_RESULT"
if [[ ${ANT_RESULT} == *"Build failed"* || ${ANT_RESULT} == *"BUILD FAILED"* ]]; then
	echo "[w] Error executing upgrade data buildfile, please contact with kiuwan support"
	exit 1
fi
docker exec -it ${KIUWAN_HOST} mv -f ${DIR_RELEASE}/todeploy.version ${DIR_RELEASE}/current.version

# call update clients launcher (mandatory when updating kiuwan)
./updateClientsLauncher.sh

# update sbt for Scala
docker exec -it ${KIUWAN_HOST} wget --no-check-certificate ${KIUWAN_DOWNLOAD_URL}/sbt.zip -O /opt/libraries/sbt.zip

DIR_DEPLOYMENTS=`grep "^\s*DIR_DEPLOYMENTS\s*=.*" ${settings_dir}/deployKiuwan.sh | awk -F "=" '{print $2}'`
DIR_DEPLOYMENTS=`echo ${DIR_DEPLOYMENTS} | sed "s|'||g"`
DIR_APP_TO_DEPLOY=`grep "^\s*DIR_APP_TO_DEPLOY\s*=.*" ${settings_dir}/deployKiuwan.sh | awk -F "=" '{print $2}'`
DIR_APP_TO_DEPLOY=`echo ${DIR_APP_TO_DEPLOY} | sed "s|'||g"`
docker exec -it ${KIUWAN_HOST} rsync -av  --delete --exclude '*.rollback' \
                                                             ${KIUWAN_VOL}/${DIR_DEPLOYMENTS}/${DIR_APP_TO_DEPLOY}/WEB-INF/classes/config/ \
                                                             ${KIUWAN_VOL}/deployconfig/kiuwan/configuration/WEB-INF/classes/config
# start wildfly
docker exec -it ${KIUWAN_HOST} supervisorctl start wildfly
sleep 15
docker exec -it ${KIUWAN_HOST} /bin/sh -c "/usr/bin/tail -n -1 -f ${KIUWAN_VOL}/logs/wildfly/wildfly_out.log | { /bin/sed '/started in/ q' && /usr/bin/killall tail ;}"
