#!/bin/bash

if [ "$0" != "./updateKiuwanLauncher.sh" ]; then
  clear	
  echo "[i] Please, this script must be executed without absolute path, execute it as ./updateKiuwanLauncher.sh from its owned directory"
  exit 1
fi
#
current_dir=`pwd`
cd ${current_dir}/../..
export settings_dir=`pwd`
cd ${current_dir}
#
# Check custom settings
if [ ! -e ${settings_dir}/settings.custom ]; then
 clear
 echo "[i] ${settings_dir}/settings.custom does not exist, please"
 echo "[i] this file is necesary to update kiuwan on premises"
 exit 1
fi
#
NUMBER_OF_RELEASE=`find ../downloads/master* -maxdepth 0 -type d 2>/dev/null | wc -l`
if [ ${NUMBER_OF_RELEASE} = 0 ]; then
  echo "[i] No new version of docker-for-kiuwan available, updating clients using current version..."
  ./updateKiuwan.sh $0
else
  LAST_RELEASE_KOP=`find ../downloads/master* -maxdepth 0 -type d | awk -F "/" '{print $3}' | awk -F "." '{print $2}' | sort -n | tail -n 1`
  DIR_LAST_RELEASE_KOP=../downloads/master.${LAST_RELEASE_KOP}.*
  echo "[i] Latest docker-for-kiuwan version found in ${DIR_LAST_RELEASE_KOP}, updating Kiuwan..."
  ${DIR_LAST_RELEASE_KOP}/updates/bin/updateKiuwan.sh $0
fi
